window.Gleam.initSearch([{"doc":"gacache","title":"gacache","content":"# gacache\r\n\r\n[![Package Version](https://img.shields.io/hexpm/v/gacache)](https://hex.pm/packages/gacache)\r\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gacache/)\r\n\r\n```sh\r\ngleam add gacache@1\r\n```\r\n```gleam\r\nimport gacache\r\nimport gleam/io\r\n\r\npub fn main() {\r\n  // Start a cache\r\n  let assert Ok(cache) = gacache.start() // Starts the cache\r\n  gacache.set(cache, &quot;test&quot;, &quot;val&quot;) // Set a value\r\n  gacache.set(cache, &quot;funky&quot;, &quot;1&quot;) // Set a value\r\n  let _ = io.debug(gacache.get(cache, &quot;test&quot;))// Ok(&quot;val&quot;) | The value bound to the key\r\n  io.debug(gacache.keys(cache)) // [&quot;funky&quot;, &quot;test&quot;] | All keys in the map\r\n  gacache.stop(cache) // Stops the cache\r\n}\r\n```\r\n\r\nFurther documentation can be found at &lt;https://hexdocs.pm/gacache&gt;.\r\n","url":"index.html"},{"doc":"gacache","title":"Action","content":"pub type Action(key, value) {\n  Set(key: key, value: value)\n  Get(ret: process.Subject(Result(value, Error)), key: key)\n  Clear(key: key)\n  Keys(ret: process.Subject(List(key)))\n  Reset\n  Raw(ret: process.Subject(Store(key, value)))\n  Merge(store: Store(key, value))\n  Stop\n}\n Actions are passed to the Cache to interact with its Store\nSet(key: key, value: value)\n\n\nGet(ret: process.Subject(Result(value, Error)), key: key)\n\n\nClear(key: key)\n\n\nKeys(ret: process.Subject(List(key)))\n\n\nReset\n\n\nRaw(ret: process.Subject(Store(key, value)))\n\n\nMerge(store: Store(key, value))\n\n\nStop\n\n\nSynonyms:\ngacache.Action\ngacache Action","url":"gacache.html#Action"},{"doc":"gacache","title":"Error","content":"pub type Error {\n  NotCached\n  Timeout\n}\n\nNotCached\n Provided when the Get Action is sent with a Key that has no corresponding Value\n\nTimeout\n Provided when either a Get or Raw Action cannot be completed in 10 seconds\n\nSynonyms:\ngacache.Error\ngacache Error","url":"gacache.html#Error"},{"doc":"gacache","title":"clear","content":"pub fn clear(cache: Subject(Action(a, b)), key: a) -&gt; Nil\n Removes the Value associated with the provided Key from the Store\nSynonyms:\ngacache.clear\ngacache clear","url":"gacache.html#clear"},{"doc":"gacache","title":"get","content":"pub fn get(\n  cache: Subject(Action(a, b)),\n  key: a,\n) -&gt; Result(b, Error)\n\nSynonyms:\ngacache.get\ngacache get","url":"gacache.html#get"},{"doc":"gacache","title":"keys","content":"pub fn keys(cache: Subject(Action(a, b))) -&gt; List(a)\n Returns all keys known by the Store\nSynonyms:\ngacache.keys\ngacache keys","url":"gacache.html#keys"},{"doc":"gacache","title":"merge","content":"pub fn merge(\n  cache: Subject(Action(a, b)),\n  new_store: Dict(a, b),\n) -&gt; Nil\n Merges the Store with the provided Store using dict:merge/2\nSynonyms:\ngacache.merge\ngacache merge","url":"gacache.html#merge"},{"doc":"gacache","title":"raw","content":"pub fn raw(\n  cache: Subject(Action(a, b)),\n) -&gt; Result(Dict(a, b), Error)\n Returns the Store, avoid if possible\nSynonyms:\ngacache.raw\ngacache raw","url":"gacache.html#raw"},{"doc":"gacache","title":"reset","content":"pub fn reset(cache: Subject(Action(a, b))) -&gt; Nil\n Clears the whole Store\nSynonyms:\ngacache.reset\ngacache reset","url":"gacache.html#reset"},{"doc":"gacache","title":"set","content":"pub fn set(cache: Subject(Action(a, b)), key: a, value: b) -&gt; Nil\n Updates the Store with key=value\nSynonyms:\ngacache.set\ngacache set","url":"gacache.html#set"},{"doc":"gacache","title":"start","content":"pub fn start() -&gt; Result(Subject(Action(a, b)), StartError)\n Start the cache\nSynonyms:\ngacache.start\ngacache start","url":"gacache.html#start"},{"doc":"gacache","title":"stop","content":"pub fn stop(cache: Subject(Action(a, b))) -&gt; Nil\n Stops the cache\nSynonyms:\ngacache.stop\ngacache stop","url":"gacache.html#stop"},{"doc":"gacache","title":"gacache","content":"","url":"gacache.html"}]);